/*******************************************************************
*******  Copyright (c) 2016-2017  Alexandros V. Gerbessiotis       *
******* All rights reserved; read copyag17.txt file                *
*******************************************************************/
#undef  MPILIB
#define MPILIB


/* MPI related definitions (MPI-2 MPI_Put and MPI_Get must be supported*/
#ifdef   MPILIB
#include <mpi.h>
#define AIBEGIN(X)    (MPI_Init(&argc,&argv),mpi_basetime=MPI_Wtime())
#define AIEND()       MPI_Barrier(MPI_COMM_WORLD),MPI_Finalize()
#define AIABORT(X)    MPI_Abort(MPI_COMM_WORLD, __LINE__ )
#define AIBSPINIT(X,Y,Z) {;}
#define AIPID() ((mpi_pid==-1)?(MPI_Comm_rank(MPI_COMM_WORLD,&mpi_pid),\
                mpi_pid):mpi_pid)
#define AINPROCS()  ((mpi_nprocs==-1)?(MPI_Comm_size(MPI_COMM_WORLD,\
                    &mpi_nprocs),mpi_nprocs):mpi_nprocs)    
#define AITIME()      (MPI_Wtime()-mpi_basetime)      


#define AIL()               (mpi_bsp_l)
#define AIG()               (mpi_bsp_g)
#define AISETL(X)           (mpi_bsp_l=(X))
#define AISETG(X)           (mpi_bsp_g=(X))

#define AIGET(X,Y,W,Z,R)    MPI_Get(\
                       (char *)(Z),(R),MPI_CHAR,(X),(W),(R),MPI_CHAR,win)
#define AIHPGET(X,Y,W,Z,R)  MPI_Get(\
                       (char *)(Z),(R),MPI_CHAR,(X),(W),(R),MPI_CHAR,win)
 /* Potential alternative precede AIO with MPI_Win_fence(0,aiwin[aisearch((void *)Y)]), */
#define AIOGET(X,Y,W,Z,R)   MPI_Get((char *)(Z),(R),MPI_CHAR,\
                       (X),(W),(R),MPI_CHAR,aiwin[aisearch((void *)Y)])
#define AIOHPGET(X,Y,W,Z,R) MPI_Get((char *)(Z),(R),MPI_CHAR,\
                       (X),(W),(R),MPI_CHAR,aiwin[aisearch((void *)Y)])
 /* end here */
#define AIPUT(X,Y,Z,W,R)    MPI_Put(\
                       (char *)(Y),(R),MPI_CHAR,(X),(W),(R),MPI_CHAR,win)
#define AIHPPUT(X,Y,Z,W,R)  MPI_Put(\
                       (char *)(Y),(R),MPI_CHAR,(X),(W),(R),MPI_CHAR,win)
 /* Potential alternative precede AIO with MPI_Win_fence(0,aiwin[aisearch((void *)Z)]), */
#define AIOPUT(X,Y,Z,W,R)   MPI_Put((char *)(Y),(R),MPI_CHAR,\
                       (X),(W),(R),MPI_CHAR,aiwin[aisearch((void *)Z)])
#define AIOHPPUT(X,Y,Z,W,R) MPI_Put((char *)(Y),(R),MPI_CHAR,\
                       (X),(W),(R),MPI_CHAR,aiwin[aisearch((void *)Z)]) 
 /* end here */

#define AIREGISTER(X,Y)  MPI_Win_create((char *)(X),(Y),1,MPI_INFO_NULL,MPI_COMM_WORLD,&win)  
#define AIDEREGISTER(X)  {;}  
#define AIINIT()         MPI_Win_fence(0,win)
#define AICOMMIT()	 {;}
/*
#define AISYNC()         MPI_Win_fence(0,win),MPI_Barrier(MPI_COMM_WORLD) 
*/
#define AISYNC()         MPI_Win_fence(0,win)
#define AIBARRIER()      MPI_Barrier(MPI_COMM_WORLD)

#define AI1REGISTER(X,Y) MPI_Win_create((char *)(X),(Y),1,MPI_INFO_NULL\
                             ,MPI_COMM_WORLD,&aiwin[aiinsert((void*)X)]) 
/*
#define AI1DEREGISTER(X) {aidelete(X);} 
*/
#define AI1DEREGISTER(X) {MPI_Win_free(&aiwin[aidelete(X)]);}
#define AI1INIT(Z)       MPI_Win_fence(0,aiwin[aisearch((void *)Z)])
#define AI1COMMIT()	 {;}
#define AI1SYNC(Z)       MPI_Win_fence(0,aiwin[aisearch((void *)Z)])
#define AI1BARRIER()     MPI_Barrier(MPI_COMM_WORLD)


/* next lines through before end if are also in avgmpi.h;delete them 20150610 */
/*
extern MPI_Comm comm;
extern MPI_Win  win;
extern MPI_Win  aiwin[];
extern void*    bspmpi[];
extern int bspmpi_max ;
extern int bspmpi_first;
extern int bspmpicur_max ;
extern int mpi_pid ;
extern int mpi_nprocs ;
extern double mpi_bsp_l ;
extern double mpi_bsp_g ;
extern double mpi_basetime;
*/
#endif
#include "avgmpi.h"
