/*******************************************************************
*******  Copyright (c) 2016-2017  Alexandros V. Gerbessiotis       *
******* All rights reserved; read copyag17.txt file                *
*******************************************************************/

#include "avgai.h"

#ifdef   MPILIB
#define AIMPIWINMAX   128
MPI_Comm comm;
MPI_Win  win;
MPI_Win  aiwin[AIMPIWINMAX];
void*    bspmpi[AIMPIWINMAX];
int bspmpi_max = AIMPIWINMAX;
int bspmpi_first=1;
int bspmpicur_max = 0;
int mpi_pid = -1;
int mpi_nprocs = -1;
double mpi_bsp_l = 300.0;
double mpi_bsp_g = 0.5;
double mpi_basetime=0.0;
#endif

#ifdef MPILIB
int aisearch(void * address) {
 register int i;

 for (i=bspmpi_max; i >=0; i-- ){
   if (bspmpi[i] == address) {
        return(i);
   }
 }
 return(-1);
}

int aiinsert(void *address) {
 register int i;
 if (bspmpi_first == 1) {
    bspmpi_first =0;
    for(i=0;i<bspmpi_max;i++) {
          bspmpi[i]=NULL;
    }
 }
 for(i=bspmpicur_max; i>=0 ; i--){
  if (bspmpi[i] == NULL)  {
    bspmpi[i]=address;
    bspmpicur_max++;
    return (i);
  }
 }
 /* runout of space */
 return(-1);
}

int aidelete(void *address) {
 register int i;
 for(i=bspmpicur_max-1;i>=0;i--) {
   if (bspmpi[i]==address){
     bspmpi[i]= NULL;
     bspmpicur_max --;
/*
     if (AIPID()==10) fprintf(stdout,"Droc %d i=%d %d %u\n",AIPID(),i,bspmpicur_max,address);fflush(stdout);
*/
     return(i);
   }
 }
 return(-1);
}
#endif

#ifdef PREVIOUS_AIDELETE
void aidelete(void *address) {
 register int i;
/* changing for loop direction
 for(i=bspmpicur_max-1;i>=0;i--) {
*/
 for(i=0; i< bspmpicur_max-1;++i) {
   if (bspmpi[i]==address){
     bspmpi[i]= NULL;
     bspmpicur_max --;
   }
 }
}
#endif
