/*******************************************************************
*******  Copyright (c) 1997-2017  Alexandros V. Gerbessiotis       *
*******                    and    C. J. Siniolakis                 *
******* All rights reserved; read copyag17.txt file                *
*******************************************************************/
#include <memory.h>
#include <stdlib.h>
#include "avgai.h"
#include "prdx.h"

#define M_alloc(x,y) (x)=(void *) malloc((y)*sizeof(char));
#define Ex2(X)  ((int)((unsigned int)(1)<<(X)))

int clg(int x)
{
  register int l;
  if (x <= 1) {
    return(0);
  }
  else {
    x--;l=1;
    while (x>1) {
      x=(x>>1);
      l++;
    }
    return(l);
  }
}

int bspbtndat (idata *src,idata *t,int n)
{
  idata *aux1,*aux2;
  register int  nprocs,pid,pit,size;
  register int  i,offset,mid,np,flag,ii,jj,kk;
  size=sizeof(idata);
  if ((n <= 0)||(size <= 0)) { 
    t=NULL; return n;
  }
  pid=AIPID(); nprocs=AINPROCS();
  M_alloc(aux1,n*size);
  M_alloc(aux2,n*size);
/*
  AI1REGISTER(t,n*size);
*/
  AIREGISTER((char*)aux2,n*size);  
  AICOMMIT(); AIBARRIER();
  memcpy(t,src,n*size);
  np=(int)Ex2((int )clg((int )nprocs));
  i=2; 
  while (i <= np){
    offset=(int)Ex2((int)clg(i)-1); 
    mid=i*FLOOR(pid,i)+(i-offset);
    flag =TRUE;
    while (offset > 0){
      if (flag){ 
       pit=(mid<<1)-pid-1; 
       flag=FALSE; 
      }
      else 
       pit=(pid<mid)?(pid+offset):(pid-offset);

      AIINIT();
      if ((pit >= 0 ) && (pit < nprocs)){
        AIHPPUT(pit,t,aux2,0,n*size); 
      }
      AISYNC();
      if ((pit >= 0 ) && (pit < nprocs)){
         if (pid < mid){
           ii=jj=kk=0;
           while(kk<n){
              if (t[ii]<aux2[jj]){
                aux1[kk]=t[ii];ii++;kk++;
              }
              else {
                aux1[kk]=aux2[jj];jj++;kk++;
              }
           }
         }
         else  {
           ii=jj=kk=n-1; 
           while(kk>=0){
              if(aux2[ii]>=t[jj]){
                aux1[kk] = aux2[ii]; ii--;kk--;
              }
              else {
                aux1[kk] = t[jj]; jj--;kk--;
              }
           }
         }
         memcpy(t,aux1,n*size);
      } 
      offset=(offset>>1);
      mid=(pid<mid)?(mid-offset):(mid+offset); 
      /*AIBARRIER();*/    /* If i remove this, MPI is giving me headaches on 16 procs or more */
    }
    i=(i<<1);
  } 
  AIDEREGISTER(aux2); /*AIDEREGISTER(t); */
  free((void*)aux2); free((void*)aux1);   
  return(n);    
} 


